@Library('pipeline-tools-library')_

pipeline {
    agent none

    environment {
        SURGE_LOGIN = 'alisson.sena@gmail.com'
        SURGE_TOKEN = 'b874e1f70fd0f2afefc301c5c8536edb'
    }

    stages {
        stage('build') {
            agent {
                docker {
                    image 'node:lts'
                }
                //rodar no slave remoto google cloud
                //label 'docker-slave-node'
            }
            steps {
                script {
                    slack('#docker-indra-raiz', 'RUNNING', 'SUCCESS')
                }
                dir('website') {
                    sh 'npm i'
                    sh 'npm run build'
                }
            }
            post {
                success {
                    archiveArtifacts artifacts: 'website/build/test-site/', fingerprint: true
                }
            }
        }
        stage('quality assurance') {
            parallel {
                stage('code analysis') {
                    agent {
                        docker {
                            image 'alcofo/nj8:latest'
                            args '--network sena_devopsjenkins'
                        }
                    }
                    environment {
                        scannerHome = tool 'SonarQubeScanner'
                    }
                    steps {
                        withSonarQubeEnv('sonarqube') {
                            sh '${scannerHome}/bin/sonar-scanner'
                        }
                        timeout(time: 10, unit: 'MINUTES') {
                            waitForQualityGate abortPipeline: true
                        }
                    }
                }
                stage('functional') {
                    agent {
                        docker {
                            image 'node:lts'
                        }
                    }
                    steps {
                        dir('website') {
                            sh 'npm i'
                            sh 'npm i -g wait-on broken-link-checker'
                            sh 'setsid npm start >/dev/null 2>&1 < /dev/null &'
                            //sh 'wait-on http://localhost:3000 && blc --recursive --exclude-external http://localhost:3000' 
                        }
                    }
                }
                stage('security') {
                    agent {
                        docker {
                            image 'node:lts'
                        }
                    }
                    steps {
                        dir('website') {
                            sh 'npm i -g npm-audit-pipeline'
                            sh 'npm-audit --low=5 --moderate=5 --hight=5 --critical=5' 
                        }
                    }
                }
            }
        }
        stage ('build Image') {
            agent {
                docker{
                    image 'docker'
                }
            }
            steps {
                script {
                    dockerImage = docker.build 'alcofo/docusaurus:latest'
                    docker.withRegistry('', 'dockerhub') {
                        dockerImage.push()
                    }
                }       
            }
        }
        stage ('delivery') {
            parallel{
                stage ('TST') {
                    agent {
                        docker {
                            image 'node:lts'
                        }
                    }
                    steps {
                        dir('website') {
                            sh 'npm i -g surge'
                            sh 'npm run build'
                            sh 'surge --project build/test-site/ --domain alcofo-tst-jenkinsdevops.surge.sh'
                        }
                    }
                }
                stage('homolog') {
                    input {
                        id 'deploy-homolog'
                        message 'Deseja realmente fazer isso?'
                    }
                    steps {
                        script{
                            docker.withServer('tcp://35.247.223.190:2736') {
                                sh 'docker container rm -f documentacao || true'
                                docker.withRegistry('', 'dockerhub') {
                                    docker.image('alcofo/docusaurus:latest').pull()
                                    docker.image('alcofo/docusaurus:latest')
                                        .run('-p 80:3000 --name documentacao')
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    post {
        always {
            node('master') {
                slack('#docker-indra-raiz', currentBuild.currentResult, currentBuild.currentResult)
            }
        }
    }
}